"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
var chalk_1 = __importDefault(require("chalk"));
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var enquirer_1 = __importDefault(require("enquirer"));
var utils_1 = require("./utils");
var generator_1 = require("./generator");
var exit = process.exit;
var cancel = function () {
    console.log(chalk_1.default.gray.bold('\nProject initialization was canceled.'));
    exit();
};
var createRXApp = function (projectName, options) { return __awaiter(void 0, void 0, void 0, function () {
    var useExistingDir, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!projectName) {
                    console.log(chalk_1.default.red('Project name cannot be empty.'));
                    return [2 /*return*/, exit()];
                }
                if (!utils_1.isValidProjectName(projectName)) {
                    console.log(chalk_1.default.red("Project name - " + chalk_1.default.red.bold(projectName) + " is not valid."));
                    return [2 /*return*/, exit()];
                }
                if (!fs_1.default.existsSync(projectName)) return [3 /*break*/, 4];
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, enquirer_1.default.prompt({
                        message: chalk_1.default.yellow.bold("Directory " + chalk_1.default.red.bold(projectName) + " is already exists. Continue?"),
                        initial: false,
                        name: 'useExistingDir',
                        type: 'confirm',
                    })];
            case 2:
                useExistingDir = (_b.sent()).useExistingDir;
                if (!useExistingDir) {
                    return [2 /*return*/, cancel()];
                }
                return [3 /*break*/, 4];
            case 3:
                _a = _b.sent();
                return [2 /*return*/, cancel()];
            case 4:
                new generator_1.Generator(__assign({ projectName: projectName, projectPath: path_1.default.join(process.cwd(), projectName) }, options)).run();
                return [2 /*return*/];
        }
    });
}); };
var program = new commander_1.default.Command('create-rx-app')
    .arguments('<project-directory>')
    .usage(chalk_1.default.green.bold('<project-directory>') + " [options]")
    .option('--javascript', 'generate project in JavaScript')
    .option('--skip-install', "don't automatically install dependencies")
    .option('--skip-jest', "don't automatically add Jest configuration")
    .option('--skip-yarn', "don't use Yarn for managing dependencies")
    .version(chalk_1.default.white.bold(utils_1.getVersion()), '-v, --version')
    .allowUnknownOption()
    .parse(process.argv);
if (!program.args.length) {
    program.help();
}
createRXApp(program.args.shift(), {
    javascript: !!program.javascript,
    skipInstall: !!program.skipInstall,
    skipJest: !!program.skipJest,
    yarn: !program.skipYarn && utils_1.yarnExists(),
});
