"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var child_process_1 = require("child_process");
exports.isValidProjectName = function (projectName) {
    return /^[$A-Z_][0-9A-Z_$]*$/i.test(projectName) &&
        projectName.toLowerCase() !== 'react';
};
exports.yarnExists = function () {
    try {
        child_process_1.execSync('yarn --version', { stdio: 'ignore' });
        return true;
    }
    catch (_a) {
        return false;
    }
};
exports.sortKeys = function (obj) {
    return Object.keys(obj)
        .sort(function (a, b) { return a.localeCompare(b); })
        .reduce(function (res, key) {
        var _a;
        return (__assign(__assign({}, res), (_a = {}, _a[key] = obj[key], _a)));
    }, {});
};
exports.getVersion = function () {
    return JSON.parse(fs_1.default.readFileSync(path_1.default.resolve(__dirname, '..', 'package.json'), {
        encoding: 'utf8',
    })).version;
};
